---------------------------------------------------------------------------
--                                                                       --
--  ast2dot is an ASIS application that outputs the AST in dot format.   --
--                          http://cfg.w3x.org                           --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--          Copyright (c) 2006, Raul Fechete, Georg Kienesberger         --
--                                                                       --
---------------------------------------------------------------------------
-- This file is part of ast2dot.                                         --
--                                                                       --
-- ast2dot is free software; you can redistribute it and/or modify       --
-- it under the terms of the GNU General Public License as published by  --
-- the Free Software Foundation; either version 2 of the License, or     --
-- (at your option) any later version.                                   --
--                                                                       --
-- ast2dot is distributed in the hope that it will be useful,            --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of        --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
-- GNU General Public License for more details.                          --
--                                                                       --
-- You should have received a copy of the GNU General Public License     --
-- along with ast2dot; if not, write to the Free Software                --
-- Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 --
-- USA                                                                   --
--                                                                       --
---------------------------------------------------------------------------

package body Level_List is

   procedure Set(List: in out LevelList; Level: in Natural; Id: in Natural) is
   begin

      if Level > List.Data'Last then
         raise Overflow;
      end if;

      List.Data(Level) := Id;

   end Set;

   procedure Get(List: in out LevelList; Level: in Natural; Id: out Natural) is
   begin

      if Level > List.Data'Last then
         raise Overflow;
      end if;

      if List.Data(Level) >= 0 then
         Id := List.Data(Level);
      else
         raise Unset;
      end if;

   end Get;

   procedure Empty(List: in out LevelList) is
   begin
      List.Data := (others => -1);
   end Empty;

end Level_List;
