---------------------------------------------------------------------------
--                                                                       --
--  ast2dot is an ASIS application that outputs the AST in dot format.   --
--                          http://cfg.w3x.org                           --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--          Copyright (c) 2006, Raul Fechete, Georg Kienesberger         --
--                                                                       --
---------------------------------------------------------------------------
-- This file is part of ast2dot.                                         --
--                                                                       --
-- ast2dot is free software; you can redistribute it and/or modify       --
-- it under the terms of the GNU General Public License as published by  --
-- the Free Software Foundation; either version 2 of the License, or     --
-- (at your option) any later version.                                   --
--                                                                       --
-- ast2dot is distributed in the hope that it will be useful,            --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of        --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
-- GNU General Public License for more details.                          --
--                                                                       --
-- You should have received a copy of the GNU General Public License     --
-- along with ast2dot; if not, write to the Free Software                --
-- Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 --
-- USA                                                                   --
--                                                                       --
---------------------------------------------------------------------------

package Level_List is

   type LevelList(Size: Positive) is limited private;

   procedure Set(List: in out LevelList; Level: in Natural; Id: in Natural);
   procedure Get(List: in out LevelList; Level: in Natural; Id: out Natural);
   procedure Empty(List: in out LevelList);

   Overflow, Unset: exception;

private

   type Vector is array(Natural range <>) of Integer;
   type LevelList(Size: Positive) is
     record
        Data: Vector(0..Size) := (others => -1);
     end record;

end Level_List;
